!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module DistrbSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: distrbset.f90,v 1.4 2005/02/02 11:07:39 odakker Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!νͤ netCDF ե뤫. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module distrbset
  implicit none
  save
                                                                 !=begin
  !== Public Interface
  real(8), allocatable   :: fs_VelXDistrb(:,:)  !® u
  real(8), allocatable   :: sf_VelZDistrb(:,:)  !® w
  real(8), allocatable   :: ss_ExnerDistrb(:,:) !̵
  real(8), allocatable   :: ss_PotTempDistrb(:,:) !
                                                                 !=end

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !νͤ netCDF ե뤫. 
  !netCDF ͤ뤿 gt4f90io Ѥ. 
  !

  subroutine distrbset_init(distrbfile)
    !=== Dependency
    use dc_trace, only: BeginSub, EndSub
    use gt4_history
    use bcset,   only: ss_BC, sf_BC, fs_BC
    use gridset, only: DimXMin, DimXMax, DimZMin, DimZMax

    !=== Input 
    character(*), intent(in)  :: distrbfile  !Υե
                                                                 !=end    
    character(20)  :: name            !ѿ̾
    
    call BeginSub("distrbset_init", &
&                 fmt="%c",       &
&                 c1="Input initial disturbance variables.")

    !--- γ
    allocate(  &
         & fs_VelXDistrb(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZDistrb(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_ExnerDistrb(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTempDistrb(DimXMin:DimXMax, DimZMin:DimZMax) )
                                                                 !=begin
    !=== Get a Value from netCDF File
    name = "VelXDistrb"
    call HistoryGet( distrbfile, name, fs_VelXDistrb )

    name = "VelZDistrb"
    call HistoryGet( distrbfile, name, sf_VelZDistrb )

    name = "ExnerDistrb"
    call HistoryGet( distrbfile, name, ss_ExnerDistrb )

    name = "PotTempDistrb"
    call HistoryGet( distrbfile, name, ss_PotTempDistrb )
                                                                 !=end

    !--- 
    call boundary( ss_BC, ss_ExnerDistrb )
    call boundary( ss_BC, ss_PotTempDistrb )
    call boundary( fs_BC, fs_VelXDistrb )
    call boundary( sf_BC, sf_VelZDistrb )

    call EndSub("distrbset_init")

  end subroutine distrbset_init
  
end module distrbset
